#include "descriptor/descriptor.h"

int main(void) {

  ITEM	azzurro, nero, bianco, rosso, grigio_scuro, argento, argento_scuro, vetro, specchio, targa, 
        grigio, verde_prato, giallone, arancione, verde, rosso_scuro, arancione_scuro, verde_scuro;
  ITEM	carrozzeria, carrozzeria_parti_nere, fanali_ant, fanali_pos, interno, serrature, 
        cerchioni_ant_dx, cerchioni_pos_dx, freni_bulloni_ant_dx, freni_bulloni_pos_dx, 
        cerchioni_ant_sx, cerchioni_pos_sx, freni_bulloni_ant_sx, freni_bulloni_pos_sx, 
        gomma_ant_dx, gomma_ant_sx, gomma_pos_dx, gomma_pos_sx, 
        vetri, specchi, targa_ant, targa_pos, stemma, strada, prato, semaforo_parti_nere,
        esterno_semaforo, luce_semaforo_rosso, luce_semaforo_arancione, luce_semaforo_verde;
  ITEM	scena;

  float trasl = 0;
  float trasl_auto = 0;
  float rotaz_ruote = 0;
  int i;

  /* creazione delle luci */

  set_background(0.6,0.8,0.9,TRUE);
  set_ambient_light(1,1,1,0.7);
  create_point_light(-14,15,7,1,1,1,3.89,20, "light1");
  create_point_light(-12,-12,7,1,1,1,4,20, "light2");
  create_point_light(-2.5,0,16,1,1,1,3.89,25, "light3");

  /* creazione dei colori */

  azzurro = create_attribute("azzurro");
  //set_color(azzurro,0.2,0.4,1,0.5,0.5);
  set_color(azzurro,0,0.4,0.6,0.5,0.5);
  set_reflectivity(azzurro,0.2,10);

  nero = create_attribute("nero");
  set_color(nero,0.05,0.05,0.05,0.5,0.5);
  set_reflectivity(nero,0.1,15);

  bianco = create_attribute("bianco");
  set_color(bianco,0.9,0.9,0.9,0.5,0.5);
  set_reflectivity(bianco,0.24,2);
  set_transparency(bianco,0.19,0.08,1,1.2);

  rosso = create_attribute("rosso");
  set_color(rosso,0.8,0,0,0.5,0.5);
  set_reflectivity(rosso,0.1,0.2);

  grigio_scuro = create_attribute("grigio_scuro");
  set_color(grigio_scuro,0.1,0.1,0.1,0.2,0.2);

  argento = create_attribute("argento");
  set_color(argento,0.75,0.75,0.75,0.1,1);
  set_reflectivity(argento,0.2,128);

  argento_scuro = create_attribute("argento_scuro");
  set_color(argento_scuro,0.1,0.1,0.1,0,1);
  set_reflectivity(argento_scuro,0.3,128);

  vetro = create_attribute("vetro");
  set_color(vetro,0.68,0.86,1,0.5,0.5);
  set_reflectivity(vetro,0.24,2);
  set_transparency(vetro,1,1,1,1.2);

  specchio = create_attribute("specchio");
  set_color(specchio,0.3,0.3,0.3,1,0);
  set_reflectivity(specchio,1.0,128);

  grigio = create_attribute("grigio");
  set_color(grigio,0.3,0.3,0.3,0.5,0.5);

  verde_prato = create_attribute("verde_prato");
  set_color(verde_prato,0,0.4,0,0.5,0.5);

  targa = create_attribute("targa");
  set_color(targa,0.9,0.9,0.9,0.5,0.5);

  giallone = create_attribute("giallone");
  set_color(giallone,0.8,0.6,0,0.5,0.5);

  arancione = create_attribute("arancione");
  set_color(arancione,1,0.4,0,0.5,0.5);

  verde = create_attribute("verde");
  set_color(verde,0,0.8,0,0.5,0.5);

  rosso_scuro = create_attribute("rosso_scuro");
  set_color(rosso_scuro,0.4,0,0,0.5,0.5);

  arancione_scuro = create_attribute("arancione_scuro");
  set_color(arancione_scuro,0.6,0.2,0,0.5,0.5);

  verde_scuro = create_attribute("verde_scuro");
  set_color(verde_scuro,0,0.2,0,0.5,0.5);

  /* caricamento degli oggetti e collegamento ai colori */

  carrozzeria = read_obj("azzurro.obj", "carrozzeria");
  set_attribute(carrozzeria, azzurro);

  carrozzeria_parti_nere = read_obj("nero.obj", "carrozzeria_parti_nere");
  set_attribute(carrozzeria_parti_nere, nero);

  fanali_ant = read_obj("bianco.obj", "fanali_anteriori");
  set_domain_texture(fanali_ant,bianco,"textures/vetro_fanali.hr",0,1,0,1,FALSE,0.4,0.4);

  fanali_pos = read_obj("rosso.obj", "fanali_posteriori");
  set_attribute(fanali_pos, rosso);

  interno = read_nurbs("interno.db");
  set_attribute(interno, grigio_scuro);

  serrature = read_obj("argento.obj", "serrature");
  set_attribute(serrature, argento);

  cerchioni_ant_dx = read_obj("argento_ruote_ant_dx.obj", "cerchioni_anteriori_dx");
  set_attribute(cerchioni_ant_dx, argento);

  cerchioni_ant_sx = read_obj("argento_ruote_ant_sx.obj", "cerchioni_anteriori_sx");
  set_attribute(cerchioni_ant_sx, argento);

  cerchioni_pos_dx = read_obj("argento_ruote_pos_dx.obj", "cerchioni_posteriori_dx");
  set_attribute(cerchioni_pos_dx, argento);

  cerchioni_pos_sx = read_obj("argento_ruote_pos_sx.obj", "cerchioni_posteriori_sx");
  set_attribute(cerchioni_pos_sx, argento);

  freni_bulloni_ant_dx = read_obj("argento_scuro_ruote_ant_dx.obj", "freni_e_bulloni_anteriori_dx");
  set_attribute(freni_bulloni_ant_dx, argento_scuro);

  freni_bulloni_ant_sx = read_obj("argento_scuro_ruote_ant_sx.obj", "freni_e_bulloni_anteriori_sx");
  set_attribute(freni_bulloni_ant_sx, argento_scuro);

  freni_bulloni_pos_dx = read_obj("argento_scuro_ruote_pos_dx.obj", "freni_e_bulloni_posteriori_dx");
  set_attribute(freni_bulloni_pos_dx, argento_scuro);

  freni_bulloni_pos_sx = read_obj("argento_scuro_ruote_pos_sx.obj", "freni_e_bulloni_posteriori_sx");
  set_attribute(freni_bulloni_pos_sx, argento_scuro);

  gomma_ant_dx = read_nurbs("gomma_ant_dx.db");
  set_attribute(gomma_ant_dx, nero);

  gomma_ant_sx = read_nurbs("gomma_ant_sx.db");
  set_attribute(gomma_ant_sx, nero);

  gomma_pos_dx = read_nurbs("gomma_pos_dx.db");
  set_attribute(gomma_pos_dx, nero);

  gomma_pos_sx = read_nurbs("gomma_pos_sx.db");
  set_attribute(gomma_pos_sx, nero);

  vetri = read_obj("trasparente_vetri.obj", "vetri");
  set_attribute(vetri, vetro);

  specchi = read_obj("specchio.obj", "specchi");
  set_attribute(specchi, specchio);

  strada = read_nurbs("strada.db");
  set_projection_texture(strada,grigio,"textures/asfalto.hr",2,TRUE,0.4,0.4);

  prato = read_obj("prato.obj", "prato");
  set_projection_texture(prato,verde_prato,"textures/grass.hr",2,TRUE,0.4,0.4);

  targa_ant = read_nurbs("targa_ant.db");
  set_domain_texture(targa_ant,targa,"textures/targa.hr",1,0,1,0,FALSE,0.4,0.4);

  targa_pos = read_nurbs("targa_pos.db");
  set_domain_texture(targa_pos,targa,"textures/targa.hr",0,1,1,0,FALSE,0.4,0.4);

  stemma = read_nurbs("stemma_ant.db");
  set_domain_texture(stemma,argento,"textures/stemma.hr",1,0,1,0,FALSE,0.2,0.2);

  semaforo_parti_nere = read_obj("semaforo_nero.obj", "semaforo_parti_nere");
  set_attribute(semaforo_parti_nere, nero);

  esterno_semaforo = read_nurbs("esterno_semaforo.db");
  set_attribute(esterno_semaforo, giallone);

  luce_semaforo_rosso = read_nurbs("luce_semaforo_rosso.db");
  set_attribute(luce_semaforo_rosso, rosso_scuro);

  luce_semaforo_arancione = read_nurbs("luce_semaforo_arancione.db");
  set_attribute(luce_semaforo_arancione, arancione_scuro);

  luce_semaforo_verde = read_nurbs("luce_semaforo_verde.db");
  set_attribute(luce_semaforo_verde, verde);

  /* creazione della scena */

  scena = create_list(carrozzeria, "scena");
  scena = insert_in_list(scena, carrozzeria_parti_nere);
  scena = insert_in_list(scena, fanali_ant);
  scena = insert_in_list(scena, fanali_pos);
  scena = insert_in_list(scena, interno);
  scena = insert_in_list(scena, serrature);
  scena = insert_in_list(scena, cerchioni_ant_dx);
  scena = insert_in_list(scena, cerchioni_pos_dx);
  scena = insert_in_list(scena, freni_bulloni_ant_dx);
  scena = insert_in_list(scena, freni_bulloni_pos_dx);
  scena = insert_in_list(scena, cerchioni_ant_sx);
  scena = insert_in_list(scena, cerchioni_pos_sx);
  scena = insert_in_list(scena, freni_bulloni_ant_sx);
  scena = insert_in_list(scena, freni_bulloni_pos_sx);
  scena = insert_in_list(scena, gomma_ant_dx);
  scena = insert_in_list(scena, gomma_ant_sx);
  scena = insert_in_list(scena, gomma_pos_dx);
  scena = insert_in_list(scena, gomma_pos_sx);
  scena = insert_in_list(scena, vetri);
  scena = insert_in_list(scena, specchi);
  scena = insert_in_list(scena, strada);
  scena = insert_in_list(scena, prato);
  scena = insert_in_list(scena, targa_ant);
  scena = insert_in_list(scena, targa_pos);
  scena = insert_in_list(scena, stemma);
  scena = insert_in_list(scena, semaforo_parti_nere);
  scena = insert_in_list(scena, esterno_semaforo);
  scena = insert_in_list(scena, luce_semaforo_rosso);
  scena = insert_in_list(scena, luce_semaforo_arancione);
  scena = insert_in_list(scena, luce_semaforo_verde);

  for (i=0; i<100; i++)
  {
	/* impostazione del valore di rotazione delle ruote e di traslazione dell'auto 
	   in modo da rallentare e poi fermare l'auto */
	if (i <= 40){
		rotaz_ruote = -5;
		trasl_auto = 0.18;
	}else if (i > 40 && i <= 60){
		rotaz_ruote = -4;
		trasl_auto = 0.12;
	}else if (i > 60 && i <= 75){
		rotaz_ruote = -3;
		trasl_auto = 0.07;
	}else if (i > 75 && i <= 85){
		rotaz_ruote = -2;
		trasl_auto = 0.04;
	}else if (i > 85 && i <= 90){
		rotaz_ruote = -1;
		trasl_auto = 0.02;
	}else if (i > 90 && i <= 100){
		rotaz_ruote = 0;
		trasl_auto = 0;
	}

	// aggiornamento del valore di traslazione complessiva dell'auto
	trasl += trasl_auto;

	// traslazione di tutta la macchina per farla ruotare
	set_translate(carrozzeria,0,trasl_auto,0);
	set_translate(carrozzeria_parti_nere,0,trasl_auto,0);
	set_translate(fanali_ant,0,trasl_auto,0);
	set_translate(fanali_pos,0,trasl_auto,0);
	set_translate(interno,0,trasl_auto,0);
	set_translate(serrature,0,trasl_auto,0);
	set_translate(cerchioni_ant_dx,0,trasl_auto,0);
	set_translate(cerchioni_pos_dx,0,trasl_auto,0);
	set_translate(freni_bulloni_ant_dx,0,trasl_auto,0);
	set_translate(freni_bulloni_pos_dx,0,trasl_auto,0);
	set_translate(cerchioni_ant_sx,0,trasl_auto,0);
	set_translate(cerchioni_pos_sx,0,trasl_auto,0);
	set_translate(freni_bulloni_ant_sx,0,trasl_auto,0);
	set_translate(freni_bulloni_pos_sx,0,trasl_auto,0);
	set_translate(gomma_ant_dx,0,trasl_auto,0);
	set_translate(gomma_pos_dx,0,trasl_auto,0);
	set_translate(gomma_ant_sx,0,trasl_auto,0);
	set_translate(gomma_pos_sx,0,trasl_auto,0);
	set_translate(vetri,0,trasl_auto,0);
	set_translate(specchi,0,trasl_auto,0);
	set_translate(targa_ant,0,trasl_auto,0);
	set_translate(targa_pos,0,trasl_auto,0);
	set_translate(stemma,0,trasl_auto,0);


	/* rotazione delle ruote per permettere l'avanzamento dell'auto
	   per fare ciò è necessario traslare le varie parti delle gomme nell'origine,
	   ruotarle su se stesse e riportarle nella posizion di partenza */
    set_translate(gomma_ant_dx,-0.42515,-trasl,0);
    set_x_rotate(gomma_ant_dx, rotaz_ruote, 1);
    set_translate(gomma_ant_dx,0.42515,trasl,0);
    set_translate(gomma_ant_sx,0.42515,-trasl,0);
    set_x_rotate(gomma_ant_sx, rotaz_ruote, 1);
    set_translate(gomma_ant_sx,-0.42515,trasl,0);
    set_translate(gomma_pos_dx,-0.42515,2.15-trasl,0);
    set_x_rotate(gomma_pos_dx, rotaz_ruote, 1);
    set_translate(gomma_pos_dx,0.42515,-2.15+trasl,0);
    set_translate(gomma_pos_sx,0.42515,2.15-trasl,0);
    set_x_rotate(gomma_pos_sx, rotaz_ruote, 1);
    set_translate(gomma_pos_sx,-0.42515,-2.15+trasl,0);

	set_translate(cerchioni_ant_dx,-0.42515,-trasl,0);
    set_x_rotate(cerchioni_ant_dx, rotaz_ruote, 1);
    set_translate(cerchioni_ant_dx,0.42515,trasl,0);
    set_translate(cerchioni_ant_sx,0.42515,-trasl,0);
    set_x_rotate(cerchioni_ant_sx, rotaz_ruote, 1);
    set_translate(cerchioni_ant_sx,-0.42515,trasl,0);
    set_translate(cerchioni_pos_dx,-0.42515,2.15-trasl,0);
    set_x_rotate(cerchioni_pos_dx, rotaz_ruote, 1);
    set_translate(cerchioni_pos_dx,0.42515,-2.15+trasl,0);
    set_translate(cerchioni_pos_sx,0.42515,2.15-trasl,0);
    set_x_rotate(cerchioni_pos_sx, rotaz_ruote, 1);
    set_translate(cerchioni_pos_sx,-0.42515,-2.15+trasl,0);

	set_translate(freni_bulloni_ant_dx,-0.42515,-trasl,0);
    set_x_rotate(freni_bulloni_ant_dx, rotaz_ruote, 1);
    set_translate(freni_bulloni_ant_dx,0.42515,trasl,0);
    set_translate(freni_bulloni_ant_sx,0.42515,-trasl,0);
    set_x_rotate(freni_bulloni_ant_sx, rotaz_ruote, 1);
    set_translate(freni_bulloni_ant_sx,-0.42515,trasl,0);
    set_translate(freni_bulloni_pos_dx,-0.42515,2.15-trasl,0);
    set_x_rotate(freni_bulloni_pos_dx, rotaz_ruote, 1);
    set_translate(freni_bulloni_pos_dx,0.42515,-2.15+trasl,0);
    set_translate(freni_bulloni_pos_sx,0.42515,2.15-trasl,0);
    set_x_rotate(freni_bulloni_pos_sx, rotaz_ruote, 1);
    set_translate(freni_bulloni_pos_sx,-0.42515,-2.15+trasl,0);

	// cambiamento dei colori del semaforo in determinati momenti
	if (i > 35 && i <= 70){
		set_attribute(luce_semaforo_verde, verde_scuro);
		set_attribute(luce_semaforo_arancione, arancione);
	}else if (i > 70){
		set_attribute(luce_semaforo_arancione, arancione_scuro);
		set_attribute(luce_semaforo_rosso, rosso);
	}
	
	// salvataggio dell'animazione
    save_scene_ani(100,"modello_206cc_anim.ani", "modello_206cc_anim", "scena", scena);
  }
  return(0);
}
